/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package statelesssessionconsumerclient;

/**
 * Test class to examine behaviour of concurrent JMS consumption from an input queue
 * using multiple instances of a stateless session bean.
 *
 * @author slossr1
 */
public class ConcurrentJMSConsumptionTest {

    //default number of threads
    private int numOfThreads = 10;

    /**
     * @param args the command line arguments, can pass optional [--t numberOfThreads]
     */
    public static void main(String[] args) {
        ConcurrentJMSConsumptionTest concurrentJMSTest = new ConcurrentJMSConsumptionTest();
        if(args!=null || args.length>0) {
            concurrentJMSTest.processArgsForThreads(args);
        }
        concurrentJMSTest.runTest();
    }

    private void runTest() {
        ThreadManager tMan = new ThreadManager();
        tMan.setNumberOfThreads(numOfThreads);
        tMan.spawnPrompters();
        System.out.println("test is running, consuming with "+numOfThreads+ " threads, check GlassFish server.log and status of INPUT.Q on OpenMQ broker.");
    }

    private void processArgsForThreads(String[] args) {
        if(args==null || args.length==0) {
            return;//continue with defaults
        }
        if(args.length==1 && args[0].equals("?") || args[0].equals("help")) {
            printUsageAndExit(false);
        }
        if(args.length!=2 && args[0].equals("--t")) {
            printUsageAndExit(true);
        }
        try {
            numOfThreads = Integer.parseInt(args[1]);
        } catch (NumberFormatException nfe) {
            System.err.println(nfe);
            printUsageAndExit(true);
        }
    }

    private void printUsageAndExit(boolean incorrectUse) {
        StringBuilder sb = new StringBuilder();
        if(incorrectUse) {
            sb.append("Incorrect usage detected, u");
        } else {
            sb.append("U");
        }
        sb.append("sage is limited to a single optional argument: [--t numberOfThreads]");
        System.out.println(sb.toString());
        System.exit(0);
    }

}
